diff --git a/doc/src/sgml/maintenance.sgml b/doc/src/sgml/maintenance.sgml
new file mode 100644
index fe1e0ed..49b1ae4
*** a/doc/src/sgml/maintenance.sgml
--- b/doc/src/sgml/maintenance.sgml
***************
*** 108,116 ****
       </listitem>
  
       <listitem>
!       <simpara>To protect against loss of very old data due to
!       <firstterm>transaction ID wraparound</> or
!       <firstterm>multixact ID wraparound</>.</simpara>
       </listitem>
      </orderedlist>
  
--- 108,115 ----
       </listitem>
  
       <listitem>
!       <simpara>To shrink <literal>pg_clog</> and
!       <literal>pg_multixact</>.</simpara>
       </listitem>
      </orderedlist>
  
***************
*** 376,382 ****
    </sect2>
  
    <sect2 id="vacuum-for-wraparound">
!    <title>Preventing Transaction ID Wraparound Failures</title>
  
     <indexterm zone="vacuum-for-wraparound">
      <primary>transaction ID</primary>
--- 375,381 ----
    </sect2>
  
    <sect2 id="vacuum-for-wraparound">
!    <title>Forced shrinking <literal>pg_clog</> and <literal>pg_multixact</></title>
  
     <indexterm zone="vacuum-for-wraparound">
      <primary>transaction ID</primary>
***************
*** 394,408 ****
      depend on being able to compare transaction ID (<acronym>XID</>)
      numbers: a row version with an insertion XID greater than the current
      transaction's XID is <quote>in the future</> and should not be visible
!     to the current transaction.  But since transaction IDs have limited size
!     (32 bits) a cluster that runs for a long time (more
      than 4 billion transactions) would suffer <firstterm>transaction ID
      wraparound</>: the XID counter wraps around to zero, and all of a sudden
      transactions that were in the past appear to be in the future &mdash; which
!     means their output become invisible.  In short, catastrophic data loss.
!     (Actually the data is still there, but that's cold comfort if you cannot
!     get at it.)  To avoid this, it is necessary to vacuum every table
!     in every database at least once every two billion transactions.
     </para>
  
     <para>
--- 393,422 ----
      depend on being able to compare transaction ID (<acronym>XID</>)
      numbers: a row version with an insertion XID greater than the current
      transaction's XID is <quote>in the future</> and should not be visible
!     to the current transaction.  In older versions transaction IDs have
!     limited size (32 bits), and a cluster that runs for a long time (more
      than 4 billion transactions) would suffer <firstterm>transaction ID
      wraparound</>: the XID counter wraps around to zero, and all of a sudden
      transactions that were in the past appear to be in the future &mdash; which
!     means data loss as their output become invisible.
!    </para>
! 
!    <para>
!     <productname>Postgres Pro Enterprise 9.6</productname> introduced
!     64-bit transaction IDs, which are not subject to wraparound and
!     do not need modulo-2<superscript>32</> arithmetic to be compared.
!     Each tuple header contain two XIDs, so extending them would lead to
!     high overhead.  For that reason on-page XIDs are still 32-bit, but
!     each page's header contains an offset, called <firstterm>epoch</>,
!     to which they are added before comparing with each other.
!    </para>
! 
!    <para>
!     When new xid can't fit existing page according to its <firstterm>epoch</>,
!     those <firstterm>epoch</> is shifted.  Single page freeze takes place if
!     needed.  Both actions are performed "on the fly".  Page-level wraparound
!     can happen only when someone holds snapshot which is more than 4 billions
!     transaction oid. 
     </para>
  
     <para>
***************
*** 411,435 ****
      they were inserted by a transaction that committed sufficiently far in
      the past that the effects of the inserting transaction are certain to be
      visible to all current and future transactions.
!     Normal XIDs are
!     compared using modulo-2<superscript>32</> arithmetic. This means
!     that for every normal XID, there are two billion XIDs that are
!     <quote>older</> and two billion that are <quote>newer</>; another
!     way to say it is that the normal XID space is circular with no
!     endpoint. Therefore, once a row version has been created with a particular
!     normal XID, the row version will appear to be <quote>in the past</> for
!     the next two billion transactions, no matter which normal XID we are
!     talking about. If the row version still exists after more than two billion
!     transactions, it will suddenly appear to be in the future. To
!     prevent this, <productname>PostgreSQL</> reserves a special XID,
!     <literal>FrozenTransactionId</>, which does not follow the normal XID
!     comparison rules and is always considered older
      than every normal XID.
      Frozen row versions are treated as if the inserting XID were
      <literal>FrozenTransactionId</>, so that they will appear to be
!     <quote>in the past</> to all normal transactions regardless of wraparound
!     issues, and so such row versions will be valid until deleted, no matter
!     how long that is.
     </para>
  
     <note>
--- 425,445 ----
      they were inserted by a transaction that committed sufficiently far in
      the past that the effects of the inserting transaction are certain to be
      visible to all current and future transactions.
!     <productname>&productname;</> reserves a special XID,
!     <literal>FrozenTransactionId</>, which is always considered older
      than every normal XID.
      Frozen row versions are treated as if the inserting XID were
      <literal>FrozenTransactionId</>, so that they will appear to be
!     <quote>in the past</> to all normal transactions.
!    </para>
! 
!    <para>
!     Freezing data by <command>VACUUM</> is not needed anymore for preventing
!     wraparound, since page-level freeze happens "on the fly".  However,
!     freezing data by <command>VACUUM</> is still needed for shrink
!     <literal>pg_clog</> and <literal>pg_multixact</>.  For historical reasons,
!     wording "autovacuum to prevent wraparound" is preserved for forced
!     atuvacuum for shrink <literal>pg_clog</> and <literal>pg_multixact</>.
     </para>
  
     <note>
***************
*** 481,492 ****
     </para>
  
     <para>
!     The maximum time that a table can go unvacuumed is two billion
!     transactions minus the <varname>vacuum_freeze_min_age</> value at
!     the time of the last aggressive vacuum. If it were to go
!     unvacuumed for longer than
!     that, data loss could result.  To ensure that this does not happen,
!     autovacuum is invoked on any table that might contain unfrozen rows with
      XIDs older than the age specified by the configuration parameter <xref
      linkend="guc-autovacuum-freeze-max-age">.  (This will happen even if
      autovacuum is disabled.)
--- 491,497 ----
     </para>
  
     <para>
!     Autovacuum is invoked on any table that might contain unfrozen rows with
      XIDs older than the age specified by the configuration parameter <xref
      linkend="guc-autovacuum-freeze-max-age">.  (This will happen even if
      autovacuum is disabled.)
***************
*** 512,525 ****
      <varname>autovacuum_freeze_max_age</>; a setting higher than that will be
      capped to the maximum. A value higher than
      <varname>autovacuum_freeze_max_age</> wouldn't make sense because an
!     anti-wraparound autovacuum would be triggered at that point anyway, and
      the 0.95 multiplier leaves some breathing room to run a manual
      <command>VACUUM</> before that happens.  As a rule of thumb,
      <command>vacuum_freeze_table_age</> should be set to a value somewhat
      below <varname>autovacuum_freeze_max_age</>, leaving enough gap so that
      a regularly scheduled <command>VACUUM</> or an autovacuum triggered by
      normal delete and update activity is run in that window.  Setting it too
!     close could lead to anti-wraparound autovacuums, even though the table
      was recently vacuumed to reclaim space, whereas lower values lead to more
      frequent aggressive vacuuming.
     </para>
--- 517,532 ----
      <varname>autovacuum_freeze_max_age</>; a setting higher than that will be
      capped to the maximum. A value higher than
      <varname>autovacuum_freeze_max_age</> wouldn't make sense because an
!     autovacuum to shrink <literal>pg_clog</> and <literal>pg_multixact</>
!     would be triggered at that point anyway, and
      the 0.95 multiplier leaves some breathing room to run a manual
      <command>VACUUM</> before that happens.  As a rule of thumb,
      <command>vacuum_freeze_table_age</> should be set to a value somewhat
      below <varname>autovacuum_freeze_max_age</>, leaving enough gap so that
      a regularly scheduled <command>VACUUM</> or an autovacuum triggered by
      normal delete and update activity is run in that window.  Setting it too
!     close could lead to autovacuums to to shrink <literal>pg_clog</> and
!     <literal>pg_multixact</>, even though the table
      was recently vacuumed to reclaim space, whereas lower values lead to more
      frequent aggressive vacuuming.
     </para>
*************** SELECT datname, age(datfrozenxid) FROM p
*** 601,643 ****
      be forced for the table.
     </para>
  
-    <para>
-     If for some reason autovacuum fails to clear old XIDs from a table,
-     the system will begin to emit warning messages like this when the
-     database's oldest XIDs reach ten million transactions from the wraparound
-     point:
- 
- <programlisting>
- WARNING:  database "mydb" must be vacuumed within 177009986 transactions
- HINT:  To avoid a database shutdown, execute a database-wide VACUUM in "mydb".
- </programlisting>
- 
-     (A manual <command>VACUUM</> should fix the problem, as suggested by the
-     hint; but note that the <command>VACUUM</> must be performed by a
-     superuser, else it will fail to process system catalogs and thus not
-     be able to advance the database's <structfield>datfrozenxid</>.)
-     If these warnings are
-     ignored, the system will shut down and refuse to start any new
-     transactions once there are fewer than 1 million transactions left
-     until wraparound:
- 
- <programlisting>
- ERROR:  database is not accepting commands to avoid wraparound data loss in database "mydb"
- HINT:  Stop the postmaster and vacuum that database in single-user mode.
- </programlisting>
- 
-     The 1-million-transaction safety margin exists to let the
-     administrator recover without data loss, by manually executing the
-     required <command>VACUUM</> commands.  However, since the system will not
-     execute commands once it has gone into the safety shutdown mode,
-     the only way to do this is to stop the server and start the server in single-user
-     mode to execute <command>VACUUM</>.  The shutdown mode is not enforced
-     in single-user mode.  See the <xref linkend="app-postgres"> reference
-     page for details about using single-user mode.
-    </para>
- 
     <sect3 id="vacuum-for-multixact-wraparound">
!     <title>Multixacts and Wraparound</title>
  
      <indexterm>
       <primary>MultiXactId</primary>
--- 608,615 ----
      be forced for the table.
     </para>
  
     <sect3 id="vacuum-for-multixact-wraparound">
!     <title>Shrinking <literal>pg_multixact</></title>
  
      <indexterm>
       <primary>MultiXactId</primary>
*************** HINT:  Stop the postmaster and vacuum th
*** 658,669 ****
       particular multixact ID is stored separately in
       the <filename>pg_multixact</> subdirectory, and only the multixact ID
       appears in the <structfield>xmax</> field in the tuple header.
!      Like transaction IDs, multixact IDs are implemented as a
!      32-bit counter and corresponding storage, all of which requires
!      careful aging management, storage cleanup, and wraparound handling.
       There is a separate storage area which holds the list of members in
!      each multixact, which also uses a 32-bit counter and which must also
!      be managed.
      </para>
  
      <para>
--- 630,641 ----
       particular multixact ID is stored separately in
       the <filename>pg_multixact</> subdirectory, and only the multixact ID
       appears in the <structfield>xmax</> field in the tuple header.
!      Like transaction IDs, multixact IDs are implemented on disk page as a
!      64-bit counter with an offset relative to epoch, and corresponding storage,
!      which requires
!      careful aging management, and storage cleanup.
       There is a separate storage area which holds the list of members in
!      each multixact, which uses a 64-bit counter.
      </para>
  
      <para>
*************** HINT:  Stop the postmaster and vacuum th
*** 691,704 ****
      </para>
  
      <para>
!      As a safety device, an aggressive vacuum scan will occur for any table
       whose multixact-age is greater than
!      <xref linkend="guc-autovacuum-multixact-freeze-max-age">.  Aggressive
!      vacuum scans will also occur progressively for all tables, starting with
!      those that have the oldest multixact-age, if the amount of used member
!      storage space exceeds the amount 50% of the addressable storage space.
!      Both of these kinds of aggressive scans will occur even if autovacuum is
!      nominally disabled.
      </para>
     </sect3>
    </sect2>
--- 663,671 ----
      </para>
  
      <para>
!      An aggressive vacuum scan will occur for any table
       whose multixact-age is greater than
!      <xref linkend="guc-autovacuum-multixact-freeze-max-age">.
      </para>
     </sect3>
    </sect2>
diff --git a/doc/src/sgml/ref/create_table.sgml b/doc/src/sgml/ref/create_table.sgml
new file mode 100644
index b15c19d..086bd11
*** a/doc/src/sgml/ref/create_table.sgml
--- b/doc/src/sgml/ref/create_table.sgml
*************** FROM ( { <replaceable class="PARAMETER">
*** 1133,1143 ****
       If true, the autovacuum daemon will perform automatic <command>VACUUM</>
       and/or <command>ANALYZE</> operations on this table following the rules
       discussed in <xref linkend="autovacuum">.
!      If false, this table will not be autovacuumed, except to prevent
!      transaction ID wraparound. See <xref linkend="vacuum-for-wraparound"> for
!      more about wraparound prevention.
!      Note that the autovacuum daemon does not run at all (except to prevent
!      transaction ID wraparound) if the <xref linkend="guc-autovacuum">
       parameter is false; setting individual tables' storage parameters does
       not override that.  Therefore there is seldom much point in explicitly
       setting this storage parameter to <literal>true</>, only
--- 1133,1144 ----
       If true, the autovacuum daemon will perform automatic <command>VACUUM</>
       and/or <command>ANALYZE</> operations on this table following the rules
       discussed in <xref linkend="autovacuum">.
!      If false, this table will not be autovacuumed, except to shrink
!      <literal>pg_clog</> and <literal>pg_multixact</>.
!      See <xref linkend="vacuum-for-wraparound"> for more about that.
!      Note that the autovacuum daemon does not run at all (except to shrink
!      <literal>pg_clog</> and <literal>pg_multixact</>) if the
!      <xref linkend="guc-autovacuum">
       parameter is false; setting individual tables' storage parameters does
       not override that.  Therefore there is seldom much point in explicitly
       setting this storage parameter to <literal>true</>, only
diff --git a/doc/src/sgml/ref/prepare_transaction.sgml b/doc/src/sgml/ref/prepare_transaction.sgml
new file mode 100644
index 626753f..62f8a2c
*** a/doc/src/sgml/ref/prepare_transaction.sgml
--- b/doc/src/sgml/ref/prepare_transaction.sgml
*************** PREPARE TRANSACTION <replaceable class="
*** 125,133 ****
     <para>
      It is unwise to leave transactions in the prepared state for a long time.
      This will interfere with the ability of <command>VACUUM</> to reclaim
!     storage, and in extreme cases could cause the database to shut down
!     to prevent transaction ID wraparound (see <xref
!     linkend="vacuum-for-wraparound">).  Keep in mind also that the transaction
      continues to hold whatever locks it held.  The intended usage of the
      feature is that a prepared transaction will normally be committed or
      rolled back as soon as an external transaction manager has verified that
--- 125,131 ----
     <para>
      It is unwise to leave transactions in the prepared state for a long time.
      This will interfere with the ability of <command>VACUUM</> to reclaim
!     storage.  Keep in mind also that the transaction
      continues to hold whatever locks it held.  The intended usage of the
      feature is that a prepared transaction will normally be committed or
      rolled back as soon as an external transaction manager has verified that
diff --git a/doc/src/sgml/storage.sgml b/doc/src/sgml/storage.sgml
new file mode 100644
index a156693..8e74ad3
*** a/doc/src/sgml/storage.sgml
--- b/doc/src/sgml/storage.sgml
*************** This information can also be used
*** 646,652 ****
  by <link linkend="indexes-index-only-scans"><firstterm>index-only
  scans</></link> to answer queries using only the index tuple.
  The second bit, if set, means that all tuples on the page have been frozen.
- That means that even an anti-wraparound vacuum need not revisit the page.
  </para>
  
  <para>
--- 646,651 ----
*************** data. Empty in ordinary tables.</entry>
*** 772,778 ****
  
   <para>
  
!   The first 24 bytes of each page consists of a page header
    (<structname>PageHeaderData</>). Its format is detailed in <xref
    linkend="pageheaderdata-table">. The first field tracks the most
    recent WAL entry related to this page. The second field contains
--- 771,777 ----
  
   <para>
  
!   The first 40 bytes of each page consists of a page header
    (<structname>PageHeaderData</>). Its format is detailed in <xref
    linkend="pageheaderdata-table">. The first field tracks the most
    recent WAL entry related to this page. The second field contains
*************** data. Empty in ordinary tables.</entry>
*** 782,788 ****
    <structfield>pd_upper</structfield>, and
    <structfield>pd_special</structfield>).  These contain byte offsets
    from the page start to the start of unallocated space, to the end of
!   unallocated space, and to the start of the special space.  The next 2
    bytes of the page header, <structfield>pd_pagesize_version</structfield>,
    store both the page size and a version indicator.  Beginning with
    <productname>PostgreSQL</productname> 8.3 the version number is 4;
--- 781,789 ----
    <structfield>pd_upper</structfield>, and
    <structfield>pd_special</structfield>).  These contain byte offsets
    from the page start to the start of unallocated space, to the end of
!   unallocated space, and to the start of the special space.
!   Next are two 8-byte fields containing base, i. e. an offset, for
!   short (4-byte) transacion IDs in this page. The next 2
    bytes of the page header, <structfield>pd_pagesize_version</structfield>,
    store both the page size and a version indicator.  Beginning with
    <productname>PostgreSQL</productname> 8.3 the version number is 4;
*************** data. Empty in ordinary tables.</entry>
*** 856,863 ****
     <entry>Page size and layout version number information</entry>
    </row>
    <row>
!    <entry>pd_prune_xid</entry>
     <entry>TransactionId</entry>
     <entry>4 bytes</entry>
     <entry>Oldest unpruned XMAX on page, or zero if none</entry>
    </row>
--- 857,876 ----
     <entry>Page size and layout version number information</entry>
    </row>
    <row>
!    <entry>pd_xid_base</entry>
!    <entry>TransactionId</entry>
!    <entry>8 bytes</entry>
!    <entry>Base for short 4-byte transaction IDs in this page</entry>
!   </row>
!   <row>
!    <entry>pd_multi_base</entry>
     <entry>TransactionId</entry>
+    <entry>8 bytes</entry>
+    <entry>Base for short 4-byte multixact IDs in this page</entry>
+   </row>
+   <row>
+    <entry>pd_prune_xid</entry>
+    <entry>ShortTransactionId</entry>
     <entry>4 bytes</entry>
     <entry>Oldest unpruned XMAX on page, or zero if none</entry>
    </row>
*************** data. Empty in ordinary tables.</entry>
*** 915,921 ****
   <para>
  
    All table rows are structured in the same way. There is a fixed-size
!   header (occupying 23 bytes on most machines), followed by an optional null
    bitmap, an optional object ID field, and the user data. The header is
    detailed
    in <xref linkend="heaptupleheaderdata-table">.  The actual user data
--- 928,934 ----
   <para>
  
    All table rows are structured in the same way. There is a fixed-size
!   header (occupying 40 bytes on most machines), followed by an optional null
    bitmap, an optional object ID field, and the user data. The header is
    detailed
    in <xref linkend="heaptupleheaderdata-table">.  The actual user data
*************** data. Empty in ordinary tables.</entry>
*** 953,965 ****
   <tbody>
    <row>
     <entry>t_xmin</entry>
!    <entry>TransactionId</entry>
     <entry>4 bytes</entry>
     <entry>insert XID stamp</entry>
    </row>
    <row>
     <entry>t_xmax</entry>
!    <entry>TransactionId</entry>
     <entry>4 bytes</entry>
     <entry>delete XID stamp</entry>
    </row>
--- 966,978 ----
   <tbody>
    <row>
     <entry>t_xmin</entry>
!    <entry>ShortTransactionId</entry>
     <entry>4 bytes</entry>
     <entry>insert XID stamp</entry>
    </row>
    <row>
     <entry>t_xmax</entry>
!    <entry>ShortTransactionId</entry>
     <entry>4 bytes</entry>
     <entry>delete XID stamp</entry>
    </row>
*************** data. Empty in ordinary tables.</entry>
*** 971,977 ****
    </row>
    <row>
     <entry>t_xvac</entry>
!    <entry>TransactionId</entry>
     <entry>4 bytes</entry>
     <entry>XID for VACUUM operation moving a row version</entry>
    </row>
--- 984,990 ----
    </row>
    <row>
     <entry>t_xvac</entry>
!    <entry>ShortTransactionId</entry>
     <entry>4 bytes</entry>
     <entry>XID for VACUUM operation moving a row version</entry>
    </row>
diff --git a/src/backend/access/common/heaptuple.c b/src/backend/access/common/heaptuple.c
new file mode 100644
index c0086de..c723dc8
*** a/src/backend/access/common/heaptuple.c
--- b/src/backend/access/common/heaptuple.c
*************** heap_getsysattr(HeapTuple tup, int attnu
*** 568,577 ****
  			result = ObjectIdGetDatum(HeapTupleGetOid(tup));
  			break;
  		case MinTransactionIdAttributeNumber:
! 			result = TransactionIdGetDatum(HeapTupleHeaderGetRawXmin(tup->t_data));
  			break;
  		case MaxTransactionIdAttributeNumber:
! 			result = TransactionIdGetDatum(HeapTupleHeaderGetRawXmax(tup->t_data));
  			break;
  		case MinCommandIdAttributeNumber:
  		case MaxCommandIdAttributeNumber:
--- 568,577 ----
  			result = ObjectIdGetDatum(HeapTupleGetOid(tup));
  			break;
  		case MinTransactionIdAttributeNumber:
! 			result = TransactionIdGetDatum(HeapTupleGetRawXmin(tup));
  			break;
  		case MaxTransactionIdAttributeNumber:
! 			result = TransactionIdGetDatum(HeapTupleGetRawXmax(tup));
  			break;
  		case MinCommandIdAttributeNumber:
  		case MaxCommandIdAttributeNumber:
*************** heap_copytuple(HeapTuple tuple)
*** 616,621 ****
--- 616,622 ----
  	newTuple->t_len = tuple->t_len;
  	newTuple->t_self = tuple->t_self;
  	newTuple->t_tableOid = tuple->t_tableOid;
+ 	HeapTupleCopyBase(newTuple, tuple);
  	newTuple->t_data = (HeapTupleHeader) ((char *) newTuple + HEAPTUPLESIZE);
  	memcpy((char *) newTuple->t_data, (char *) tuple->t_data, tuple->t_len);
  	return newTuple;
*************** heap_copytuple_with_tuple(HeapTuple src,
*** 642,647 ****
--- 643,649 ----
  	dest->t_len = src->t_len;
  	dest->t_self = src->t_self;
  	dest->t_tableOid = src->t_tableOid;
+ 	HeapTupleCopyBase(dest, src);
  	dest->t_data = (HeapTupleHeader) palloc(src->t_len);
  	memcpy((char *) dest->t_data, (char *) src->t_data, src->t_len);
  }
*************** heap_form_tuple(TupleDesc tupleDescripto
*** 752,757 ****
--- 754,760 ----
  	tuple->t_len = len;
  	ItemPointerSetInvalid(&(tuple->t_self));
  	tuple->t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(tuple);
  
  	HeapTupleHeaderSetDatumLength(td, len);
  	HeapTupleHeaderSetTypeId(td, tupleDescriptor->tdtypeid);
*************** heap_modify_tuple(HeapTuple tuple,
*** 840,845 ****
--- 843,849 ----
  	newTuple->t_data->t_ctid = tuple->t_data->t_ctid;
  	newTuple->t_self = tuple->t_self;
  	newTuple->t_tableOid = tuple->t_tableOid;
+ 	HeapTupleCopyBase(newTuple, tuple);
  	if (tupleDesc->tdhasoid)
  		HeapTupleSetOid(newTuple, HeapTupleGetOid(tuple));
  
*************** heap_tuple_from_minimal_tuple(MinimalTup
*** 1504,1509 ****
--- 1508,1514 ----
  	result->t_len = len;
  	ItemPointerSetInvalid(&(result->t_self));
  	result->t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(result);
  	result->t_data = (HeapTupleHeader) ((char *) result + HEAPTUPLESIZE);
  	memcpy((char *) result->t_data + MINIMAL_TUPLE_OFFSET, mtup, mtup->t_len);
  	memset(result->t_data, 0, offsetof(HeapTupleHeaderData, t_infomask2));
